/*
 * http://www.primefaces.org/showcase/ui/df/data.xhtml
 */
package org.primefaces.showcase.view.df;
 
import java.io.Serializable;
import java.util.List;
import javax.annotation.PostConstruct;
import javax.faces.bean.ManagedBean;
import javax.faces.bean.ManagedProperty;
import javax.faces.bean.ViewScoped;
import org.primefaces.context.RequestContext;
import org.primefaces.showcase.domain.Car;
import org.primefaces.showcase.service.CarService;
 
@ManagedBean(name = "dfCarsView")
@ViewScoped
public class DFCarsView implements Serializable {
     
  private List<Car> cars;

  @ManagedProperty("#{carService}")
  private CarService service;

  @PostConstruct
  public void init() {
    if (service == null) {
      service = new CarService();
    }
    cars = service.populateCars(9);
  }

  public List<Car> getCars() {
    return cars;
  }

  public void setService(CarService service) {
    this.service = service;
  }

  public void selectCarFromDialog(Car car) {
    RequestContext.getCurrentInstance().closeDialog(car);
  }
}
